/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.inputDevice;

import kinugasa.contents.resource.ContentsFileNotFoundException;
import kinugasa.util.annotations.Internal;

/**
 * Q[pbh͂𔻒肷邽߂́ukgp.dllv[h܂.
 * <br>
 *
 * <br>
 * @version 1.0.0 - 2013/04/20_21:15:20<br>
 * @author Dra0211<br>
 */
public class KGPDllLoader {

	/**
	 * CX^Xł܂.
	 */
	private KGPDllLoader() {
	}

	/**
	 * staticCjVCUNADLL[h܂.
	 */
	@Internal
	public static void load() {
	}

	static {
		try {
			System.loadLibrary("kgp");
			System.out.println("> kpg load success");
		} catch (Throwable t) {
			System.out.println("! > kgp Load FAIL");
			throw new ContentsFileNotFoundException("/kgp.dll NOT FOUND");
		}
	}
}
